<?php

#-------------------------------------------------------------------------------
/** @author Alex Keda, for www.host-food.ru */
/******************************************************************************/
/******************************************************************************/
$__args_list = Array('IsCreate','Folder');
/******************************************************************************/
Eval(COMP_INIT);
/******************************************************************************/
/******************************************************************************/
if(Is_Error(System_Load('libs/Artichow.php')))
  return ERROR | @Trigger_Error(500);
#-------------------------------------------------------------------------------
$Result = Array('Title'=>'Распределение доходов/заказов на VPS по тарифам');
#-------------------------------------------------------------------------------
if(!$IsCreate)
  return $Result;
#-------------------------------------------------------------------------------
$NoBody = new Tag('NOBODY');
#-------------------------------------------------------------------------------
$NoBody->AddChild(new Tag('P','Данный вид статистики содержит информацию о доходности/нагрузке каждого из имеющихся тарифов VPS за 1 месяц (30 дней)'));
$NoBody->AddChild(new Tag('P','Суммируются цены за месяц, всех активных заказов тарифа.'));
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
$Graphs = Array();	# для построения графиков на выхлопе
#-------------------------------------------------------------------------------
# перебираем группы серверов, ищщем те где автобалансировка не отключена
$VPSSchemes = DB_Select('VPSSchemes',Array('*'),Array('SortOn'=>'SortID'));
switch(ValueOf($VPSSchemes)){
case 'error':
	return ERROR | @Trigger_Error(500);
case 'exception':
	Debug("[comp/Statistics/VPSSchemesIncome]: hosting shemes not found");
	break;
case 'array':
	# All OK, Servers Groups found
	break;
default:
	return ERROR | @Trigger_Error(101);
}
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
$Table = Array(Array(new Tag('TD',Array('class'=>'Head'),'Наименование тарифа'),new Tag('TD',Array('class'=>'Head'),'Кол-во заказов'),new Tag('TD',Array('class'=>'Head'),'Доход')));
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
foreach($VPSSchemes as $VPSScheme){
	#-------------------------------------------------------------------------------
	$Balance = 0;
	$Accounts = 0;
	$NumPaid = 0;
	$Params = $Labels = Array();
	#-------------------------------------------------------------------------------
	# достаём все активные аккаунты тарифа
	$SchemeAccounts = DB_Select('VPSOrders',Array('OrderID'),Array('Where'=>SPrintF('`SchemeID` = %u AND `StatusID` = "Active"',$VPSScheme['ID'])));
	#-------------------------------------------------------------------------------
	switch(ValueOf($SchemeAccounts)){
	case 'error':
		return ERROR | @Trigger_Error(500);
	case 'exception':
		#-------------------------------------------------------------------------------
		Debug(SPrintF('[comp/Statistics/VPSSchemesIncome]: scheme "%s" not have active accounts',$VPSScheme['Name']));
		#-------------------------------------------------------------------------------
		$SchemeIncome = Comp_Load('Formats/Currency',0);
		if(Is_Error($SchemeIncome))
			return ERROR | @Trigger_Error(500);
		#-------------------------------------------------------------------------------
		$Table[] = Array($VPSScheme['Name'],'0 / 0',$SchemeIncome);
		#-------------------------------------------------------------------------------
		break;
		#-------------------------------------------------------------------------------
	case 'array':
		# All OK, accounts found
		#-------------------------------------------------------------------------------
		#-------------------------------------------------------------------------------
		$Array = Array();
		#-------------------------------------------------------------------------------
		foreach($SchemeAccounts as $Account)
			$Array[] = $Account['OrderID'];
			#-------------------------------------------------------------------------------
		#-------------------------------------------------------------------------------
		# считаем сумму всех оплаченных дней тарифа
		$Where = Array('`DaysRemainded` > 0','`Discont` < 1','`Cost` > 0',SPrintF('`OrderID` IN (%s)',Implode(',',$Array)));
		#-------------------------------------------------------------------------------
		$Income = DB_Select('OrdersConsider',Array('SUM(`DaysRemainded`*`Cost`*(1-`Discont`)) as `SummRemainded`','SUM(`DaysRemainded`) AS `DaysRemainded`'),Array('UNIQ','Where'=>$Where));
		#-------------------------------------------------------------------------------
		switch(ValueOf($Income)){
		case 'error':
			return ERROR | @Trigger_Error(500);
		case 'exception':
			Debug(SPrintF('[comp/Statistics/VPSSchemesIncome]: no summ for scheme "%s"',$VPSScheme['Name']));
			break;
		case 'array':
			#-------------------------------------------------------------------------------
			# считаем все не-бесплатные аккаунты, по ним будут расчёты цены и доходов
			$Count = DB_Select('OrdersConsider','DISTINCT(`OrderID`) AS `OrderID`',Array('Where'=>$Where));
			#-------------------------------------------------------------------------------
			switch(ValueOf($Count)){
			case 'error':
				return ERROR | @Trigger_Error(500);
			case 'exception':
				#-------------------------------------------------------------------------------
				$PaidAccounts = 0;
				#-------------------------------------------------------------------------------
				break;
				#-------------------------------------------------------------------------------
			case 'array':
				#-------------------------------------------------------------------------------
				# All OK, accounts found
				$PaidAccounts = SizeOf($Count);
				#-------------------------------------------------------------------------------
				break;
				#-------------------------------------------------------------------------------
			default:
				return ERROR | @Trigger_Error(101);
			}
			#-------------------------------------------------------------------------------
			$NumAccounts = SizeOf($Array);
			#-------------------------------------------------------------------------------
			$SchemeIncome = (IntVal($Income['DaysRemainded']) > 0)?(($Income['SummRemainded'] / $Income['DaysRemainded']) * $PaidAccounts * 30):0;
			$SchemeIncome = Comp_Load('Formats/Currency',$SchemeIncome);# 30 дней в месяце
			if(Is_Error($SchemeIncome))
				return ERROR | @Trigger_Error(500);
			#-------------------------------------------------------------------------------
			$Table[] = Array($VPSScheme['Name'],SPrintF('%s / %s',$NumAccounts,$PaidAccounts),$SchemeIncome);
			#-------------------------------------------------------------------------------
			break;
			#-------------------------------------------------------------------------------
		default:
			return ERROR | @Trigger_Error(101);
		}
		#-------------------------------------------------------------------------------
                break;
		#-------------------------------------------------------------------------------
	default:
		return ERROR | @Trigger_Error(101);
	}
	#-------------------------------------------------------------------------------
}
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
$Comp = Comp_Load('Tables/Extended',$Table);
if(Is_Error($Comp))
	return ERROR | @Trigger_Error(500);
#----------------------------------------------------------------------------
$NoBody->AddChild($Comp);
#-------------------------------------------------------------------------------
$Result['DOM'] = $NoBody;
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
return $Result;
#-------------------------------------------------------------------------------
?>
