<?php
#-------------------------------------------------------------------------------
/** @author Бреславский А.В. (Joonte Ltd.) */
#-------------------------------------------------------------------------------
/*------------------------------------------------------------------------------
      Задача:
Проверить все присланные параметры на соответствие шаблону безопасности.
------------------------------------------------------------------------------*/
# Шаблон безопасности (регулярное выражение)
#-------------------------------------------------------------------------------
$Template = "/^(SELECT.*FROM.*|INSERT INTO|UPDATE .* SET).*/i";
#-------------------------------------------------------------------------------
$Args = &Args();
#-------------------------------------------------------------------------------
if(Count($_COOKIE) > 0){
  #-----------------------------------------------------------------------------
  Debug('[Security module]: [проверка Cookie]');
  #-----------------------------------------------------------------------------
  foreach(Array_Keys($_COOKIE) as $CookieID){
    #---------------------------------------------------------------------------
    $Cookie = $_COOKIE[$CookieID];
    #---------------------------------------------------------------------------
    Debug(SPrintF('[Security module]: (%s) = (%s)',$CookieID,$Cookie));
    #---------------------------------------------------------------------------
    if(Preg_Match($Template,$Cookie))
      return ERROR | @Trigger_Error(600);
  }
}
#-------------------------------------------------------------------------------
if(Count($Args) > 0){
  #-----------------------------------------------------------------------------
  Debug('[Security module]: [проверка параметров]');
  #-----------------------------------------------------------------------------
  foreach(Array_Keys($Args) as $ArgID){
    #---------------------------------------------------------------------------
    $Arg = &$Args[$ArgID];
    #---------------------------------------------------------------------------
    Debug(SPrintF('[Security module]: (%s) = (%s)',$ArgID,$Arg?(Is_Array($Arg)?'Array':$Arg):'EMPTY'));
    #---------------------------------------------------------------------------
    if(Is_Array($Arg)){
      #-------------------------------------------------------------------------
      foreach(Array_Keys($Arg) as $Key){
        #-----------------------------------------------------------------------
        $Element = &$Arg[$Key];
        #-----------------------------------------------------------------------
        Debug(SPrintF('[Security module]: проверка параметра (%s [%s]) = (%s)',$ArgID,$Key,Is_Array($Element)?'Array':$Element));
        #-----------------------------------------------------------------------
        if(Is_Scalar($Element) && Preg_Match($Template,$Element))
          return ERROR | @Trigger_Error(600);
      }
      #-------------------------------------------------------------------------
      continue;
    }
  }
}
#-------------------------------------------------------------------------------
?>
