<?php
#-------------------------------------------------------------------------------
$Profiles = DB_Select('Profiles','*',Array('Where'=>"`TemplateID` IN ('Juridical')"));
#-------------------------------------------------------------------------------
switch(ValueOf($Profiles)){
  case 'error':
    return ERROR | @Trigger_Error(500);
  case 'exception':
    # No more...
  break;
  case 'array':
    #---------------------------------------------------------------------------
    foreach($Profiles as $Profile){
      #-------------------------------------------------------------------------
      $Attribs = $Profile['Attribs'];
      #-------------------------------------------------------------------------
      $Director = $Attribs['Director'];
      #-------------------------------------------------------------------------
      $Director = Preg_Split('/\s+/',$Director);
      #-------------------------------------------------------------------------
      $Attribs['dSourname'] = Current($Director);
      $Attribs['dName']     = Next($Director);
      $Attribs['dLastname'] = Next($Director);
      #-------------------------------------------------------------------------
      $Attribs['NameEn']     = Translit($Attribs['dName']);
      $Attribs['LastnameEn'] = Translit(Mb_SubStr($Attribs['dLastname'],0,1));
      $Attribs['SournameEn'] = Translit($Attribs['dSourname']);
      #-------------------------------------------------------------------------
      #-------------------------------------------------------------------------
      $Attribs['jCountry']  = $Attribs['Country'];
      $Attribs['pCountry']  = $Attribs['Country'];
      #-------------------------------------------------------------------------
      $Attribs['jState']  = $Attribs['State'];
      $Attribs['pState']  = $Attribs['State'];
      $Attribs['StateEn'] = Translit($Attribs['State']);
      #-------------------------------------------------------------------------
      $Attribs['jCity']  = $Attribs['City'];
      $Attribs['pCity']  = $Attribs['City'];
      $Attribs['CityEn'] = Translit($Attribs['City']);
      #-------------------------------------------------------------------------
      $Attribs['jAddress']  = Trim(Preg_Replace('/(ул|пр)\./iu','',$Attribs['jAddress']));
      $Attribs['pAddress']  = Trim(Preg_Replace('/(ул|пр)\./iu','',$Attribs['jAddress']));
      $Attribs['AddressEn'] = Translit($Attribs['jAddress']);
      #-------------------------------------------------------------------------
      $Attribs['jIndex'] = $Attribs['PostIndex'];
      $Attribs['pIndex'] = $Attribs['PostIndex'];
      #-------------------------------------------------------------------------
      #-------------------------------------------------------------------------
      $CompanyName = $Attribs['CompanyName'];
      #-------------------------------------------------------------------------
      $CompanyName = Preg_Split('/\s+/',$CompanyName);
      #-------------------------------------------------------------------------
      $Attribs['Form'] = Current($CompanyName);
      #-------------------------------------------------------------------------
      UnSet($CompanyName[0]);
      #-------------------------------------------------------------------------
      $CompanyName = Implode(' ',$CompanyName);
      #-------------------------------------------------------------------------
      if(Preg_Match('/(общество\sс\sограниченной\sответственностью)\s(.+)/ui',$CompanyName,$Matches)){
        #-----------------------------------------------------------------------
        $Attribs['Form'] = 'ООО';
        #-----------------------------------------------------------------------
        $CompanyName = $Matches[2];
        #-----------------------------------------------------------------------
      }elseif(Preg_Match('/(закрытое\sакционерное\sобщество)\s(.+)/ui',$CompanyName,$Matches)){
        #-----------------------------------------------------------------------
        $Attribs['Form'] = 'ЗАО';
        #-----------------------------------------------------------------------
        $CompanyName = $Matches[2];
        #-----------------------------------------------------------------------
      }elseif(Preg_Match('/(открытое\sакционерное\sобщество)\s(.+)/ui',$CompanyName,$Matches)){
        #-----------------------------------------------------------------------
        $Attribs['Form'] = 'ОАО';
        #-----------------------------------------------------------------------
        $CompanyName = $Matches[2];
        #-----------------------------------------------------------------------
      }
      #-------------------------------------------------------------------------
      $Attribs['CompanyName'] = Trim($CompanyName,'"');
      #-------------------------------------------------------------------------
      #-------------------------------------------------------------------------
      if(IsSet($Attribs['CompanyNameEn']))
        $Attribs['CompanyNameEn'] = Str_Replace('"','',$Attribs['CompanyNameEn']);
      #-------------------------------------------------------------------------
      #-------------------------------------------------------------------------
      $Attribs['Ogrn'] = '';
      #-------------------------------------------------------------------------
      #-------------------------------------------------------------------------
      $Template = System_XML(SPrintF('profiles/%s.xml',$Profile['TemplateID']));
      if(Is_Error($Template))
        return ERROR | @Trigger_Error(500);
      #-------------------------------------------------------------------------
      foreach(Array_Keys($Template['Attribs']) as $AttribID){
        #-----------------------------------------------------------------------
        if(!IsSet($Attribs[$AttribID]))
          $Attribs[$AttribID] = $Template['Attribs'][$AttribID]['Value'];
      }
      #-------------------------------------------------------------------------
      foreach(Array_Keys($Attribs) as $AttribID){
        #-----------------------------------------------------------------------
        if(!IsSet($Template['Attribs'][$AttribID]))
          UnSet($Attribs[$AttribID]);
      }
      #-------------------------------------------------------------------------
      $IsUpdate = DB_Update('Profiles',Array('Attribs'=>$Attribs),Array('ID'=>$Profile['ID']));
      if(Is_Error($IsUpdate))
        return ERROR | @Trigger_Error(500);
    }
  break;
  default:
    return ERROR | @Trigger_Error(101);
}
#-------------------------------------------------------------------------------
return TRUE;
#-------------------------------------------------------------------------------
?>